package com.sun.jndi.url.iiop;

import javax.naming.NamingException;
import com.sun.jndi.cosnaming.CNCtx;
import javax.naming.spi.ResolveResult;
import java.util.Hashtable;
import javax.naming.Context;
import javax.naming.Name;
import javax.naming.spi.ObjectFactory;

public class iiopURLContextFactory implements ObjectFactory
{
    public iiopURLContextFactory() {
    }
    
    @Override
    public Object getObjectInstance(Object o, Name name, Context context, Hashtable<?, ?> hashtable) throws Exception {
        if (o == null) {
            return new iiopURLContext(hashtable);
        }
        if ((o instanceof String)) {
            return getUsingURL((String)o, hashtable);
        }
        if ((o instanceof String[])) {
            return getUsingURLs((String[])(String[])o, hashtable);
        }
        throw new IllegalArgumentException("iiopURLContextFactory.getObjectInstance: argument must be a URL String or array of URLs");
    }
    
    static ResolveResult getUsingURLIgnoreRest(String s, Hashtable<?, ?> hashtable) throws NamingException {
        return CNCtx.createUsingURL(s, hashtable);
    }
    
    private static Object getUsingURL(String s, Hashtable<?, ?> hashtable) throws NamingException {
        ResolveResult usingURLIgnoreRest = getUsingURLIgnoreRest(s, hashtable);
        Context context = (Context)usingURLIgnoreRest.getResolvedObj();
        try {
            return context.lookup(usingURLIgnoreRest.getRemainingName());
        }
        finally {
            context.close();
        }
    }
    
    private static Object getUsingURLs(String[] array, Hashtable<?, ?> hashtable) {
        for (int i = 0; i < array.length; ++i) {
            String s = array[i];
            try {
                Object usingURL = getUsingURL(s, hashtable);
                if (usingURL != null) {
                    return usingURL;
                }
            }
            catch (NamingException ex) {}
        }
        return null;
    }
}
